import 'bootstrap.css';
import '@mescius/wijmo.styles/wijmo.css';
import './styles.css';
import * as wjCore from '@mescius/wijmo';
import * as wjGrid from '@mescius/wijmo.grid';
//
document.readyState === 'complete' ? init() : window.onload = init;
//
function init() {
//
// generate some random data
var countries = 'US,Germany,UK,Japan,Italy,Greece'.split(','), products = 'Phones,Computers,Cameras,Stereos'.split(','), data = [];
for (var i = 0; i < 200; i++) {
data.push({
id: i,
country: countries[i % countries.length],
product: products[i % products.length],
sales: Math.random() * 10000,
expenses: Math.random() * 5000,
});
}
//
// create a group to show the grand totals
var grandTotalsGroup = new wjCore.PropertyGroupDescription('Grand Total', function (item, propName) {
return '';
});
//
// grid with custom aggregates
var theGrid = new wjGrid.FlexGrid('#theGrid', {
autoGenerateColumns: false,
columns: [
{ binding: 'id', header: 'ID', width: 60, isReadOnly: true },
{ binding: 'country', header: 'Country' },
{ binding: 'product', header: 'Product' },
{ binding: 'sales', header: 'Sales', aggregate: 'Sum' },
{ binding: 'expenses', header: 'Expenses', aggregate: 'Sum' },
{ binding: 'profit', header: 'Profit', dataType: 'Number', isReadOnly: true, allowSorting: false }
],
itemsSource: new wjCore.CollectionView(data, {
groupDescriptions: [
grandTotalsGroup,
'country'
]
})
});
//
// start collapsed
theGrid.collapseGroupsToLevel(1);
//
// custom cell calculation
theGrid.formatItem.addHandler(function (s, e) {
//
// cells and column footer panels only
if (e.panel == s.cells) {
//
// get row, column, and data item (or group description)
var r = s.rows[e.row];
var c = s.columns[e.col];
var item = s.rows[e.row].dataItem;
var group = r instanceof wjGrid.GroupRow ? item : null;
//
// assume value is not negative
var negative = false;
//
// calculate profit
if (c.binding == 'profit') {
var profit = group
? group.getAggregate('Sum', 'sales') - group.getAggregate('Sum', 'expenses')
: item.sales - item.expenses;
e.cell.textContent = wjCore.Globalize.format(profit, c.format);
negative = profit < 0;
}
//
// update 'negative' class on cell
wjCore.toggleClass(e.cell, 'negative', negative);
}
//
});
}
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo FlexGrid Custom Aggregation</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- SystemJS -->
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.5/dist/system.src.js" integrity="sha512-skZbMyvYdNoZfLmiGn5ii6KmklM82rYX2uWctBhzaXPxJgiv4XBwJnFGr5k8s+6tE1pcR1nuTKghozJHyzMcoA==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('./src/app');
</script>
</head>
<body>
<main class="container-fluid">
<div id="theGrid">
</div>
</main>
</body>
</html>
.wj-flexgrid {
max-height: 250px;
margin: 10px 0;
}
.wj-cell.wj-frozen-row {
border-bottom: none;
}
.negative {
color: red;
}
body {
margin-bottom: 20px;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
},
meta: {
'*.css': { loader: 'css' },
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/wijmojs/5.20261.52-rc/',
'pcdn:': 'https://cdn.jsdelivr.net/npm/'
},
// map tells the System loader where to look for things
map: {
'@mescius/wijmo': 'cdn:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'cdn:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'cdn:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'cdn:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'cdn:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'cdn:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'cdn:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'cdn:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'cdn:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'cdn:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'cdn:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'cdn:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'cdn:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'cdn:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'cdn:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'cdn:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'cdn:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'cdn:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'cdn:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'cdn:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'cdn:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'cdn:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'cdn:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'cdn:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'cdn:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'cdn:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'cdn:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'cdn:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'cdn:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'cdn:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'cdn:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.nav': 'cdn:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'cdn:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'cdn:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'cdn:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'cdn:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'cdn:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'cdn:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'cdn:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'cdn:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'cdn:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.touch': 'cdn:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'cdn:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.barcode': 'cdn:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'cdn:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'cdn:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'cdn:@mescius/wijmo.barcode.specialized/index.js',
jszip: 'pcdn:jszip@3.8.0/dist/jszip.js',
'bootstrap.css': 'pcdn:bootstrap@5.3.8/dist/css/bootstrap.min.css',
css: 'pcdn:systemjs-plugin-css@0.1.37/css.js',
'plugin-babel': 'pcdn:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'pcdn:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'js',
},
node_modules: {
defaultExtension: 'js',
},
},
});
})(this);

import 'bootstrap.css';
import '@mescius/wijmo.styles/wijmo.css';
import './styles.css';
import '@angular/compiler';
import { Component, enableProdMode, ɵresolveComponentResources } from '@angular/core';
import { BrowserModule, bootstrapApplication } from '@angular/platform-browser';
import { WjGridModule } from '@mescius/wijmo.angular2.grid';
import * as wjcCore from '@mescius/wijmo';
import * as wjcGrid from '@mescius/wijmo.grid';
@Component({
standalone: true,
imports: [WjGridModule, BrowserModule],
selector: 'app-component',
templateUrl: 'src/app.component.html',
})
export class AppComponent {
data: wjcCore.CollectionView;
// DataSvc will be passed by derived classes
constructor() {
this.data = new wjcCore.CollectionView(this._getData(), {
groupDescriptions: [
new wjcCore.PropertyGroupDescription('Grand Total', () => {
return '';
}),
'country',
],
});
}
initializeGrid(flex: wjcGrid.FlexGrid) {
// start collapsed
flex.collapseGroupsToLevel(1);
// custom cell calculation
flex.formatItem.addHandler((s: wjcGrid.FlexGrid, e: wjcGrid.FormatItemEventArgs) => {
// cells and column footer panels only
if (e.panel == s.cells) {
// get row, column, and data item (or group description)
let r = s.rows[e.row],
c = s.columns[e.col],
item = s.rows[e.row].dataItem,
group = r instanceof wjcGrid.GroupRow ? item : null,
negative = false; // assume value is not negative
// calculate profit
if (c.binding == 'profit') {
let profit = group
? group.getAggregate('Sum', 'sales') - group.getAggregate('Sum', 'expenses')
: item.sales - item.expenses;
e.cell.textContent = wjcCore.Globalize.format(profit, c.format);
negative = profit < 0;
}
// update 'negative' class on cell
wjcCore.toggleClass(e.cell, 'negative', negative);
}
});
}
private _getData() {
// create some random data
let countries = 'US,Germany,UK,Japan,Italy,Greece'.split(','),
products = 'Phones,Computers,Cameras,Stereos'.split(','),
data = [];
for (let i = 0; i < 200; i++) {
data.push({
id: i,
country: countries[i % countries.length],
product: products[i % products.length],
sales: Math.random() * 10000,
expenses: Math.random() * 5000,
});
}
return data;
}
}
enableProdMode();
// Resolve resources (templateUrl, styleUrls etc), After resolution all URLs have been converted into `template` strings.
ɵresolveComponentResources(fetch).then(() => {
// Bootstrap application
bootstrapApplication(AppComponent).catch((err) => console.error(err));
});
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo FlexGrid Custom Aggregation</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- Polyfills -->
<script src="https://cdn.jsdelivr.net/npm/core-js/client/shim.min.js"></script>
<!-- SystemJS -->
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.5/dist/system.src.js" integrity="sha512-skZbMyvYdNoZfLmiGn5ii6KmklM82rYX2uWctBhzaXPxJgiv4XBwJnFGr5k8s+6tE1pcR1nuTKghozJHyzMcoA==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<main class="container-fluid">
<!-- the grid -->
<wj-flex-grid #flex
[(itemsSource)]="data"
(initialized)="initializeGrid(flex)">
<wj-flex-grid-column [binding]="'id'" [header]="'ID'" [width]="60" [isReadOnly]="true"></wj-flex-grid-column>
<wj-flex-grid-column [binding]="'country'" [header]="'Country'"></wj-flex-grid-column>
<wj-flex-grid-column [binding]="'product'" [header]="'Product'"></wj-flex-grid-column>
<wj-flex-grid-column [binding]="'sales'" [header]="'Sales'" [aggregate]="'Sum'"></wj-flex-grid-column>
<wj-flex-grid-column [binding]="'expenses'" [header]="'Expenses'" [aggregate]="'Sum'"></wj-flex-grid-column>
<wj-flex-grid-column [binding]="'profit'" [header]="'Profit'" [dataType]="number" [isReadOnly]="true" [allowSorting]="false"></wj-flex-grid-column>
</wj-flex-grid>
</main>
.wj-flexgrid {
max-height: 250px;
margin: 10px 0;
}
.wj-cell.wj-frozen-row {
border-bottom: none;
}
.negative {
color: red;
}
body {
margin-bottom: 20px;
}
(function (global) {
SystemJS.config({
transpiler: './plugin-typescript.js',
typescriptOptions: {
target: 'ES2022',
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
typescript: {
exports: 'ts',
},
'*.css': { loader: 'systemjs-plugin-css' },
'*.mjs': {
format: 'esm',
},
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/wijmojs/5.20261.52-rc/',
'pcdn:': 'https://cdn.jsdelivr.net/npm/',
'agpcdn:': 'https://cdn.jsdelivr.net/npm/'
},
packageConfigPaths: ['/node_modules/*/package.json', '/node_modules/@angular/*/package.json', '/node_modules/@mescius/*/package.json'],
map: {
'core-js': 'agpcdn:core-js@2.6.12/client/shim.min.js',
'typescript': 'agpcdn:typescript@5.9.3/lib/typescript.min.js',
rxjs: 'agpcdn:rxjs@7.8.1/dist/bundles/rxjs.umd.min.js',
'systemjs-plugin-css': 'agpcdn:systemjs-plugin-css@0.1.37/css.js',
'@mescius/wijmo': 'cdn:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'cdn:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'cdn:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'cdn:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'cdn:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'cdn:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'cdn:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'cdn:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'cdn:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'cdn:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'cdn:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'cdn:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'cdn:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'cdn:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'cdn:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'cdn:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'cdn:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'cdn:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'cdn:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'cdn:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'cdn:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'cdn:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'cdn:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'cdn:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'cdn:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'cdn:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'cdn:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'cdn:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'cdn:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'cdn:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'cdn:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.nav': 'cdn:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'cdn:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'cdn:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'cdn:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'cdn:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'cdn:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'cdn:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'cdn:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'cdn:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'cdn:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.touch': 'cdn:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'cdn:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.barcode': 'cdn:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'cdn:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'cdn:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'cdn:@mescius/wijmo.barcode.specialized/index.js',
'@mescius/wijmo.angular2.chart.analytics': 'cdn:@mescius/wijmo.angular2.chart.analytics/index.js',
'@mescius/wijmo.angular2.chart.animation': 'cdn:@mescius/wijmo.angular2.chart.animation/index.js',
'@mescius/wijmo.angular2.chart.annotation': 'cdn:@mescius/wijmo.angular2.chart.annotation/index.js',
'@mescius/wijmo.angular2.chart.finance.analytics': 'cdn:@mescius/wijmo.angular2.chart.finance.analytics/index.js',
'@mescius/wijmo.angular2.chart.finance': 'cdn:@mescius/wijmo.angular2.chart.finance/index.js',
'@mescius/wijmo.angular2.chart.hierarchical': 'cdn:@mescius/wijmo.angular2.chart.hierarchical/index.js',
'@mescius/wijmo.angular2.chart.interaction': 'cdn:@mescius/wijmo.angular2.chart.interaction/index.js',
'@mescius/wijmo.angular2.chart.radar': 'cdn:@mescius/wijmo.angular2.chart.radar/index.js',
'@mescius/wijmo.angular2.chart.map': 'cdn:@mescius/wijmo.angular2.chart.map/index.js',
'@mescius/wijmo.angular2.chart': 'cdn:@mescius/wijmo.angular2.chart/index.js',
'@mescius/wijmo.angular2.core': 'cdn:@mescius/wijmo.angular2.core/index.js',
'@mescius/wijmo.angular2.gauge': 'cdn:@mescius/wijmo.angular2.gauge/index.js',
'@mescius/wijmo.angular2.grid.detail': 'cdn:@mescius/wijmo.angular2.grid.detail/index.js',
'@mescius/wijmo.angular2.grid.filter': 'cdn:@mescius/wijmo.angular2.grid.filter/index.js',
'@mescius/wijmo.angular2.grid.grouppanel': 'cdn:@mescius/wijmo.angular2.grid.grouppanel/index.js',
'@mescius/wijmo.angular2.grid.search': 'cdn:@mescius/wijmo.angular2.grid.search/index.js',
'@mescius/wijmo.angular2.grid.multirow': 'cdn:@mescius/wijmo.angular2.grid.multirow/index.js',
'@mescius/wijmo.angular2.grid.sheet': 'cdn:@mescius/wijmo.angular2.grid.sheet/index.js',
'@mescius/wijmo.angular2.grid.transposed': 'cdn:@mescius/wijmo.angular2.grid.transposed/index.js',
'@mescius/wijmo.angular2.grid.transposedmultirow': 'cdn:@mescius/wijmo.angular2.grid.transposedmultirow/index.js',
'@mescius/wijmo.angular2.grid': 'cdn:@mescius/wijmo.angular2.grid/index.js',
'@mescius/wijmo.angular2.input': 'cdn:@mescius/wijmo.angular2.input/index.js',
'@mescius/wijmo.angular2.olap': 'cdn:@mescius/wijmo.angular2.olap/index.js',
'@mescius/wijmo.angular2.viewer': 'cdn:@mescius/wijmo.angular2.viewer/index.js',
'@mescius/wijmo.angular2.nav': 'cdn:@mescius/wijmo.angular2.nav/index.js',
'@mescius/wijmo.angular2.directivebase': 'cdn:@mescius/wijmo.angular2.directivebase/index.js',
'@mescius/wijmo.angular2.barcode.common': 'cdn:@mescius/wijmo.angular2.barcode.common/index.js',
'@mescius/wijmo.angular2.barcode.composite': 'cdn:@mescius/wijmo.angular2.barcode.composite/index.js',
'@mescius/wijmo.angular2.barcode.specialized': 'cdn:@mescius/wijmo.angular2.barcode.specialized/index.js',
'bootstrap.css': 'pcdn:bootstrap@5.3.8/dist/css/bootstrap.min.css',
jszip: 'agpcdn:jszip@3.10.1/dist/jszip.min.js',
'@angular/core': 'pcdn:@angular/core@21.1.0/fesm2022/core.mjs',
'@angular/core/primitives/di': 'pcdn:@angular/core@21.1.0/fesm2022/primitives-di.mjs',
'@angular/core/primitives/signals': 'pcdn:@angular/core@21.1.0/fesm2022/primitives-signals.mjs',
'@angular/core/primitives/event-dispatch': 'pcdn:@angular/core@21.1.0/fesm2022/primitives-event-dispatch.mjs',
'@angular/common': 'pcdn:@angular/common@21.1.0/fesm2022/common.mjs',
'@angular/common/http': 'pcdn:@angular/common@21.1.0/fesm2022/http.mjs',
'@angular/compiler': 'pcdn:@angular/compiler@21.1.0/fesm2022/compiler.mjs',
'@angular/platform-browser': 'pcdn:@angular/platform-browser@21.1.0/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'pcdn:@angular/platform-browser-dynamic@21.1.0/fesm2022/platform-browser-dynamic.mjs',
'@angular/router': 'pcdn:@angular/router@21.1.0/fesm2022/router.mjs',
'@angular/forms': 'pcdn:@angular/forms@21.1.0/fesm2022/forms.mjs',
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
'./src': {
defaultExtension: 'ts',
},
node_modules: {
defaultExtension: 'js',
},
wijmo: {
defaultExtension: 'js',
},
},
});
})(this);

<template>
<main class="container-fluid">
<wj-flex-grid :itemsSource="data" :initialized="initializedGrid">
<wj-flex-grid-column binding="id" header="ID" :width="60" :isReadOnly="true" />
<wj-flex-grid-column binding="country" header="Country" />
<wj-flex-grid-column binding="product" header="Product" />
<wj-flex-grid-column binding="sales" header="Sales" aggregate="Sum" />
<wj-flex-grid-column binding="expenses" header="Expenses" aggregate="Sum" />
<wj-flex-grid-column binding="profit" header="Profit" :dataType="2" :isReadOnly="true" :allowSorting="false" />
</wj-flex-grid>
</main>
</template>
<script setup>
import * as wjcGrid from "@mescius/wijmo.grid";
import * as wjcCore from "@mescius/wijmo";
import { getData } from "./data";
import { ref } from "vue";
const data = ref(
new wjcCore.CollectionView(getData(), {
groupDescriptions: [
new wjcCore.PropertyGroupDescription("Grand Total", () => {
return "";
}),
"country",
],
}),
);
function initializedGrid(flex) {
// start collapsed
flex.collapseGroupsToLevel(1);
// custom cell calculation
flex.formatItem.addHandler((s, e) => {
// cells and column footer panels only
if (e.panel == s.cells) {
// get row, column, and data item (or group description)
let r = s.rows[e.row],
c = s.columns[e.col],
item = s.rows[e.row].dataItem,
group = r instanceof wjcGrid.GroupRow ? item : null,
negative = false; // assume value is not negative
// calculate profit
if (c.binding == "profit") {
let profit = group ? group.getAggregate("Sum", "sales") - group.getAggregate("Sum", "expenses") : item.sales - item.expenses;
e.cell.textContent = wjcCore.Globalize.format(profit, c.format);
negative = profit < 0;
}
// update 'negative' class on cell
wjcCore.toggleClass(e.cell, "negative", negative);
}
});
}
</script>
<style>
.wj-flexgrid {
max-height: 250px;
margin: 10px 0;
}
.wj-cell.wj-frozen-row {
border-bottom: none;
}
.negative {
color: red;
}
body {
margin-bottom: 20px;
}
</style>
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo FlexGrid Custom Aggregation</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- SystemJS -->
<script src="compiler.js" type="module"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.5/dist/system.src.js" integrity="sha512-skZbMyvYdNoZfLmiGn5ii6KmklM82rYX2uWctBhzaXPxJgiv4XBwJnFGr5k8s+6tE1pcR1nuTKghozJHyzMcoA==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('./src/app.js');
</script>
</head>
<body>
<div id="app">
</div>
</body>
</html>
export function getData() {
// create some random data
let countries = 'US,Germany,UK,Japan,Italy,Greece'.split(','),
products = 'Phones,Computers,Cameras,Stereos'.split(','),
data = [];
for (let i = 0; i < 200; i++) {
data.push({
id: i,
country: countries[i % countries.length],
product: products[i % products.length],
sales: Math.random() * 10000,
expenses: Math.random() * 5000
});
}
return data;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
},
meta: {
'*.css': { loader: 'css' },
'*.vue': { loader: '../plugin-vue/index.js' },
//'*.vue': { loader: 'systemjs-plugin-vue' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/wijmojs/5.20261.52-rc/',
'pcdn:': 'https://cdn.jsdelivr.net/npm/'
},
// map tells the System loader where to look for things
map: {
'@mescius/wijmo': 'cdn:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'cdn:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'cdn:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'cdn:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'cdn:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'cdn:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'cdn:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'cdn:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'cdn:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'cdn:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'cdn:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'cdn:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'cdn:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'cdn:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'cdn:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'cdn:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'cdn:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'cdn:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'cdn:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'cdn:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'cdn:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'cdn:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'cdn:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'cdn:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'cdn:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'cdn:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'cdn:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'cdn:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'cdn:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'cdn:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'cdn:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.nav': 'cdn:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'cdn:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'cdn:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'cdn:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'cdn:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'cdn:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'cdn:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'cdn:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'cdn:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'cdn:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.touch': 'cdn:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'cdn:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.barcode': 'cdn:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'cdn:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'cdn:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'cdn:@mescius/wijmo.barcode.specialized/index.js',
'@mescius/wijmo.vue2.chart.analytics': 'cdn:@mescius/wijmo.vue2.chart.analytics/index.js',
'@mescius/wijmo.vue2.chart.animation': 'cdn:@mescius/wijmo.vue2.chart.animation/index.js',
'@mescius/wijmo.vue2.chart.annotation': 'cdn:@mescius/wijmo.vue2.chart.annotation/index.js',
'@mescius/wijmo.vue2.chart.finance.analytics': 'cdn:@mescius/wijmo.vue2.chart.finance.analytics/index.js',
'@mescius/wijmo.vue2.chart.finance': 'cdn:@mescius/wijmo.vue2.chart.finance/index.js',
'@mescius/wijmo.vue2.chart.hierarchical': 'cdn:@mescius/wijmo.vue2.chart.hierarchical/index.js',
'@mescius/wijmo.vue2.chart.interaction': 'cdn:@mescius/wijmo.vue2.chart.interaction/index.js',
'@mescius/wijmo.vue2.chart.radar': 'cdn:@mescius/wijmo.vue2.chart.radar/index.js',
'@mescius/wijmo.vue2.chart.map': 'cdn:@mescius/wijmo.vue2.chart.map/index.js',
'@mescius/wijmo.vue2.chart': 'cdn:@mescius/wijmo.vue2.chart/index.js',
'@mescius/wijmo.vue2.core': 'cdn:@mescius/wijmo.vue2.core/index.js',
'@mescius/wijmo.vue2.gauge': 'cdn:@mescius/wijmo.vue2.gauge/index.js',
'@mescius/wijmo.vue2.grid.detail': 'cdn:@mescius/wijmo.vue2.grid.detail/index.js',
'@mescius/wijmo.vue2.grid.filter': 'cdn:@mescius/wijmo.vue2.grid.filter/index.js',
'@mescius/wijmo.vue2.grid.grouppanel': 'cdn:@mescius/wijmo.vue2.grid.grouppanel/index.js',
'@mescius/wijmo.vue2.grid.search': 'cdn:@mescius/wijmo.vue2.grid.search/index.js',
'@mescius/wijmo.vue2.grid.multirow': 'cdn:@mescius/wijmo.vue2.grid.multirow/index.js',
'@mescius/wijmo.vue2.grid.sheet': 'cdn:@mescius/wijmo.vue2.grid.sheet/index.js',
'@mescius/wijmo.vue2.grid.transposed': 'cdn:@mescius/wijmo.vue2.grid.transposed/index.js',
'@mescius/wijmo.vue2.grid.transposedmultirow': 'cdn:@mescius/wijmo.vue2.grid.transposedmultirow/index.js',
'@mescius/wijmo.vue2.grid': 'cdn:@mescius/wijmo.vue2.grid/index.js',
'@mescius/wijmo.vue2.input': 'cdn:@mescius/wijmo.vue2.input/index.js',
'@mescius/wijmo.vue2.olap': 'cdn:@mescius/wijmo.vue2.olap/index.js',
'@mescius/wijmo.vue2.viewer': 'cdn:@mescius/wijmo.vue2.viewer/index.js',
'@mescius/wijmo.vue2.nav': 'cdn:@mescius/wijmo.vue2.nav/index.js',
'@mescius/wijmo.vue2.base': 'cdn:@mescius/wijmo.vue2.base/index.js',
'@mescius/wijmo.vue2.barcode.common': 'cdn:@mescius/wijmo.vue2.barcode.common/index.js',
'@mescius/wijmo.vue2.barcode.composite': 'cdn:@mescius/wijmo.vue2.barcode.composite/index.js',
'@mescius/wijmo.vue2.barcode.specialized': 'cdn:@mescius/wijmo.vue2.barcode.specialized/index.js',
'bootstrap.css': 'pcdn:bootstrap@5.3.8/dist/css/bootstrap.min.css',
jszip: 'pcdn:jszip@3.8.0/dist/jszip.js',
css: 'pcdn:systemjs-plugin-css@0.1.37/css.js',
vue: 'pcdn:vue@3.4.21/dist/vue.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'vue-loader': 'pcdn:systemjs-vue-browser@1.0.11/index.js',
//'systemjs-plugin-vue': 'pcdn:systemjs-plugin-vue@1.2.0/index.js',
'plugin-babel': 'pcdn:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'pcdn:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'js',
},
rxjs: {
defaultExtension: 'js',
},
node_modules: {
defaultExtension: 'js',
},
wijmo: {
defaultExtension: 'js',
},
},
});
})(this);

import 'bootstrap.css';
import '@mescius/wijmo.styles/wijmo.css';
import ReactDOM from 'react-dom/client';
import React from 'react';
import useEvent from 'react-use-event-hook';
import { FlexGrid, FlexGridColumn } from '@mescius/wijmo.react.grid';
import { GroupRow } from '@mescius/wijmo.grid';
import { CollectionView, PropertyGroupDescription, Globalize, toggleClass } from '@mescius/wijmo';
import './app.css';
import { data } from './data';
const view = new CollectionView(data, {
groupDescriptions: [
new PropertyGroupDescription('Grand Total', () => ''),
'country'
]
});
function App() {
const initializedGrid = useEvent((flex) => {
flex.itemsSource = view;
// start collapsed
flex.collapseGroupsToLevel(1);
// custom cell calculation
flex.formatItem.addHandler((s, e) => {
// cells and column footer panels only
if (e.panel == s.cells) {
// get row, column, and data item (or group description)
let r = s.rows[e.row], c = s.columns[e.col], item = s.rows[e.row].dataItem, group = r instanceof GroupRow ? item : null, negative = false; // assume value is not negative
// calculate profit
if (c.binding == 'profit') {
let profit = group
? group.getAggregate('Sum', 'sales') - group.getAggregate('Sum', 'expenses')
: item.sales - item.expenses;
e.cell.textContent = Globalize.format(profit, c.format);
negative = profit < 0;
}
// update 'negative' class on cell
toggleClass(e.cell, 'negative', negative);
}
});
});
return (<main className="container-fluid">
<FlexGrid initialized={initializedGrid}>
<FlexGridColumn binding="id" header="ID" width={60} isReadOnly={true}/>
<FlexGridColumn binding="country" header="Country"/>
<FlexGridColumn binding="product" header="Product"/>
<FlexGridColumn binding="sales" header="Sales" aggregate="Sum"/>
<FlexGridColumn binding="expenses" header="Expenses" aggregate="Sum"/>
<FlexGridColumn binding="profit" header="Profit" dataType={2} isReadOnly={true} allowSorting={false}/>
</FlexGrid>
</main>);
}
const container = document.getElementById('app');
if (container) {
const root = ReactDOM.createRoot(container);
root.render(<App />);
}
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo Wijmo FlexGrid Custom Aggregation</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- SystemJS -->
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.19.40/dist/system.src.js" integrity="sha512-G6mEj6h18+m3MvzdviSDfPle/TfH0//cXcB33AKlNR/Rha0yQsKefDZKRTkIZos97HEGq2JMV1RT5ybMoQ3WsQ==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('./src/app');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
.wj-flexgrid {
max-height: 250px;
margin: 10px 0;
}
.wj-cell.wj-frozen-row {
border-bottom: none;
}
.negative {
color: red;
}
function getData() {
// create some random data
let countries = ['US', 'Germany', 'UK', 'Japan', 'Italy', 'Greece'], products = 'Phones,Computers,Cameras,Stereos'.split(','), data = [];
for (let i = 0; i < 200; i++) {
data.push({
id: i,
country: countries[i % countries.length],
product: products[i % products.length],
sales: Math.random() * 10000,
expenses: Math.random() * 5000
});
}
return data;
}
export const data = getData();
(function (global) {
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true,
},
meta: {
'*.css': { loader: 'css' },
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/wijmojs/5.20261.52-rc/',
'pcdn:': 'https://cdn.jsdelivr.net/npm/'
},
// map tells the System loader where to look for things
map: {
'@mescius/wijmo': 'cdn:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'cdn:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'cdn:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'cdn:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'cdn:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'cdn:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'cdn:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'cdn:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'cdn:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'cdn:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'cdn:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'cdn:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'cdn:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'cdn:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'cdn:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'cdn:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'cdn:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'cdn:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'cdn:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'cdn:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'cdn:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'cdn:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'cdn:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'cdn:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'cdn:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'cdn:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'cdn:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'cdn:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'cdn:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'cdn:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'cdn:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.grid.immutable': 'cdn:@mescius/wijmo.grid.immutable/index.js',
'@mescius/wijmo.touch': 'cdn:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'cdn:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.nav': 'cdn:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'cdn:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'cdn:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'cdn:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'cdn:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'cdn:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'cdn:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'cdn:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'cdn:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'cdn:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.barcode': 'cdn:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'cdn:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'cdn:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'cdn:@mescius/wijmo.barcode.specialized/index.js',
'@mescius/wijmo.react.chart.analytics': 'cdn:@mescius/wijmo.react.chart.analytics/index.js',
'@mescius/wijmo.react.chart.animation': 'cdn:@mescius/wijmo.react.chart.animation/index.js',
'@mescius/wijmo.react.chart.annotation': 'cdn:@mescius/wijmo.react.chart.annotation/index.js',
'@mescius/wijmo.react.chart.finance.analytics': 'cdn:@mescius/wijmo.react.chart.finance.analytics/index.js',
'@mescius/wijmo.react.chart.finance': 'cdn:@mescius/wijmo.react.chart.finance/index.js',
'@mescius/wijmo.react.chart.hierarchical': 'cdn:@mescius/wijmo.react.chart.hierarchical/index.js',
'@mescius/wijmo.react.chart.interaction': 'cdn:@mescius/wijmo.react.chart.interaction/index.js',
'@mescius/wijmo.react.chart.radar': 'cdn:@mescius/wijmo.react.chart.radar/index.js',
'@mescius/wijmo.react.chart': 'cdn:@mescius/wijmo.react.chart/index.js',
'@mescius/wijmo.react.core': 'cdn:@mescius/wijmo.react.core/index.js',
'@mescius/wijmo.react.chart.map': 'cdn:@mescius/wijmo.react.chart.map/index.js',
'@mescius/wijmo.react.gauge': 'cdn:@mescius/wijmo.react.gauge/index.js',
'@mescius/wijmo.react.grid.detail': 'cdn:@mescius/wijmo.react.grid.detail/index.js',
'@mescius/wijmo.react.grid.filter': 'cdn:@mescius/wijmo.react.grid.filter/index.js',
'@mescius/wijmo.react.grid.grouppanel': 'cdn:@mescius/wijmo.react.grid.grouppanel/index.js',
'@mescius/wijmo.react.grid.search': 'cdn:@mescius/wijmo.react.grid.search/index.js',
'@mescius/wijmo.react.grid.multirow': 'cdn:@mescius/wijmo.react.grid.multirow/index.js',
'@mescius/wijmo.react.grid.sheet': 'cdn:@mescius/wijmo.react.grid.sheet/index.js',
'@mescius/wijmo.react.grid.transposed': 'cdn:@mescius/wijmo.react.grid.transposed/index.js',
'@mescius/wijmo.react.grid.transposedmultirow': 'cdn:@mescius/wijmo.react.grid.transposedmultirow/index.js',
'@mescius/wijmo.react.grid.immutable': 'cdn:@mescius/wijmo.react.grid.immutable/index.js',
'@mescius/wijmo.react.grid': 'cdn:@mescius/wijmo.react.grid/index.js',
'@mescius/wijmo.react.input': 'cdn:@mescius/wijmo.react.input/index.js',
'@mescius/wijmo.react.olap': 'cdn:@mescius/wijmo.react.olap/index.js',
'@mescius/wijmo.react.viewer': 'cdn:@mescius/wijmo.react.viewer/index.js',
'@mescius/wijmo.react.nav': 'cdn:@mescius/wijmo.react.nav/index.js',
'@mescius/wijmo.react.base': 'cdn:@mescius/wijmo.react.base/index.js',
'@mescius/wijmo.react.barcode.common': 'cdn:@mescius/wijmo.react.barcode.common/index.js',
'@mescius/wijmo.react.barcode.composite': 'cdn:@mescius/wijmo.react.barcode.composite/index.js',
'@mescius/wijmo.react.barcode.specialized': 'cdn:@mescius/wijmo.react.barcode.specialized/index.js',
jszip: 'pcdn:jszip@3.8.0/dist/jszip.js',
react: 'pcdn:react@19.0.0/index.js',
'react-dom': 'pcdn:react-dom@19.0.0/index.js',
'react-dom/client': 'pcdn:react-dom@19.0.0/client.js',
scheduler: 'pcdn:scheduler@0.25.0/index.js',
redux: 'pcdn:redux@5.0.1/dist/redux.legacy-esm.js',
'react-redux': 'pcdn:react-redux@9.2.0/dist/react-redux.legacy-esm.js',
'bootstrap.css': 'pcdn:bootstrap@5.3.8/dist/css/bootstrap.min.css',
css: 'pcdn:systemjs-plugin-css@0.1.37/css.js',
'plugin-babel': 'pcdn:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'pcdn:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
'react-use-event-hook': 'pcdn:react-use-event-hook@0.9.6/dist/esm/useEvent.js',
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx',
},
node_modules: {
defaultExtension: 'js',
},
},
});
})(this);